unit Quelltext;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, MPlayer, ComCtrls, Buttons, unit2;

type
  TForm1 = class(TForm)
    IH: TImage;
    TLi: TTimer;
    TOb: TTimer;
    TUn: TTimer;
    TRe: TTimer;
    TZeit: TTimer;
    LZeit: TLabel;
    TH1: TTimer;
    MPMusik: TMediaPlayer;
    TH2: TTimer;
    TRi: TTimer;
    TH3: TTimer;
    BBNeu: TBitBtn;
    BBAbbruch: TBitBtn;
    LBAnzeige: TListBox;
    MPSound1: TMediaPlayer;
    THV1: TTimer;
    THV2: TTimer;
    TH4: TTimer;
    MPSound2: TMediaPlayer;
    BStart: TButton;
    TH5: TTimer;
    TH6: TTimer;
    LSong: TLabel;
    BZurueck: TButton;
    BVor: TButton;
    BPause: TButton;
    LLoop: TLabel;
    BHilfeMP: TButton;
    BHilfeSpiel: TButton;
    MPSound3: TMediaPlayer;
    LLevel: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TLiTimer(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TZeitTimer(Sender: TObject);
    procedure BPauseClick(Sender: TObject);
    procedure TObTimer(Sender: TObject);
    procedure TReTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TUnTimer(Sender: TObject);
    procedure TH1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure MPMusikNotify(Sender: TObject);
    procedure BPlayClick(Sender: TObject);
    procedure TH2Timer(Sender: TObject);
    procedure TRiTimer(Sender: TObject);
    procedure TH3Timer(Sender: TObject);
    procedure BBAbbruchClick(Sender: TObject);
    procedure BBNeuClick(Sender: TObject);
    procedure LBAnzeigeEnter(Sender: TObject);
    procedure THV1Timer(Sender: TObject);
    procedure THV2Timer(Sender: TObject);
    procedure TH4Timer(Sender: TObject);
    procedure BStartClick(Sender: TObject);
    procedure TH5Timer(Sender: TObject);
    procedure TH6Timer(Sender: TObject);
    procedure BVorClick(Sender: TObject);
    procedure BZurueckClick(Sender: TObject);
    procedure LLoopClick(Sender: TObject);
    procedure BHilfeMPClick(Sender: TObject);
    procedure BHilfeSpielClick(Sender: TObject);


  private
    { Private-Deklarationen }
      HighScorePfad : String;
  public
    { Public-Deklarationen }
     procedure FuegeZumHighScoreHinzu(Name : String; Score : Integer;
                                       Trennzeichen : Char; Trennzeichenmenge : integer;
                                       ScoreLength : integer);

  end;

var
  Form1: TForm1;
  Score, Minuten, Sekunden, PosX, PosY, H1PosX, H1PosY, H1Richtung, H2PosX, H2PosY, H2Richtung,
  H3PosX, H3PosY, H3Richtung, H4PosX, H4PosY, H4Richtung, H5PosY, H5PosX, H5Richtung, H6PosY, H6PosX,
  H6Richtung, HV1PosY, HV1PosX, HV1Richtung, HV2PosY, HV2PosX, HV2Richtung, AFail: Integer;
  Aktiv, ne : Boolean;
  HighScore : TStringList;
  Song : String;
  SongNummer : Integer;

implementation

{$R *.dfm}

procedure Delay(msec: integer);
var start, stop: LongInt;
begin
  start := GetTickCount;
  repeat
    stop := GetTickCount;
    Application.ProcessMessages;
  until (stop-start)>=msec;
end;

procedure TForm1.FuegeZumHighScoreHinzu(Name : String; Score : Integer;     //aus dem Internet
                                       Trennzeichen : Char; Trennzeichenmenge : integer; 
                                       ScoreLength : integer);
var i : integer;
    ATrennzeichen : String;
    TempStrList : TStringList;
    AScore : String;
begin
 if HighScore.Count < 2 then Exit;
 // Es mssen mindestens 2 Eintrge in der HighScoreliste bereits stehen
 if Trennzeichenmenge < 1 then Exit;
 // Weniger als ein Trennzeichen oder gar negative Trennzeichen sind nicht mglich
 for i := 1 to Trennzeichenmenge do
  begin
   ATrennzeichen := ATrennzeichen + Trennzeichen;
  end;
 // Unser Trenzeichenstring ist fertig
 AScore := intToStr(Score);
 while Length(AScore) <> ScoreLength do
  begin
   AScore := '0' + AScore;
  end;
 // Wir fllen die fehlenden Stellen im Score mit 0 auf. Damit alle Scorewerte in der Tabelle spter
 // gleich lang sind. So kommt das Programm beim Sortieren nicht durcheinander, und es sieht besser aus
 TempStrList := TStringList.Create;
 // Wir erstellen eine zweite temporre Stringlist, in der wir dann sortieren
 try
  for i := 0 to HighScore.Count-1 do
   begin     
    TempStrList.add(HighScore[i]);
   end;
  finally
   try
    TempStrList.add(AScore + ATrennzeichen + Name);
    TempStrList.Sort;
    //Sort ist eine sehr praktische Funktion der TStringList die wir benutzen
    HighScore.clear;
   finally
    try
     for i := (TempStrList.Count - 1) downto 0 do
      begin
       HighScore.add(TempStrList[i]);
      end;
      //hier fgen wir in umgekehrter Reihenfolgen die Werte aus der TempStringlist
      //in unsere HighScore Liste
      HighScore.SaveToFile(HighScorePfad); // Speichern nicht vergessen
   finally
    TempStrList.Free;
   end;
  end;
 end;
end;
 
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Aktiv = True then
  begin
    if key = vk_left
      then TLi.Enabled:=True;
    if key = vk_right
      then TRe.Enabled:=True;
    if key = vk_up
      then TOb.Enabled:=True;
    if key = vk_down
      then TUn.Enabled:=True;
  end;
If key = ord('S')                              //Steuerung MediaPlayer mit W,A,S,D
  then Form1.LLoopClick(Form1);
If MPMusik.Notify = False
  then
    begin
      If key = ord('D')
        then BVor.Click;
      If key = ord('A')
        then BZurueck.Click;
      If key = ord('w')
        then BPause.Click;
    end;
If BStart.Visible = True
  then
    if key = vk_space
      then BStart.Click;
end;





procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Aktiv = True then
  begin
    if key = vk_left
      then TLi.Enabled:=False;
    if key = vk_right
      then TRe.Enabled:=False;
    if key = vk_up
      then TOb.Enabled:=False;
    if key = vk_down
      then TUn.Enabled:=False;
  end;
end;

procedure TForm1.TZeitTimer(Sender: TObject);          //Die if-Schleifen sind fr schne Ausgabe da
begin
if aktiv = False
  then  begin
        Tzeit.Enabled:=False;
        exit;
        end;
Inc(Score,1);
if Sekunden = 59
  then
    begin
      Sekunden:=0;
      Inc(Minuten);
    end
  else inc(Sekunden);
if Sekunden < 10
  then
    begin
      if Minuten < 10
        then LZeit.Caption:='0'+IntToStr(Minuten)+':'+'0'+IntToStr(Sekunden);
      if Minuten > 10
        then LZeit.Caption:=IntToStr(Minuten)+':'+'0'+IntToStr(Sekunden)
    end
  else
    begin
      if Minuten < 10
       then LZeit.Caption:='0'+IntToStr(Minuten)+':'+IntToStr(Sekunden);
      if Minuten > 10
       then LZeit.Caption:=IntToStr(Minuten)+':'+IntToStr(Sekunden);
    end;
If Score = 10
  then begin
    THV1.Enabled:=True;
    LLevel.Caption:='Stufe 2';
  end;
If Score = 20
  then begin
    TH3.Enabled:=True;
    LLevel.Caption:='Stufe 3';
  end;
If Score = 30
  then begin
    THV2.Enabled:=True;
    LLevel.Font.Color:=clYellow;
    LLevel.Caption:='Stufe 4';
  end;
If Score = 40
  then begin
    TH4.Enabled:=True;
    LLevel.Caption:='Stufe 5';
  end;
If Score = 50
  then begin
    TH5.Enabled:=True;
    LLevel.Caption:='Stufe 6';
  end;
If Score = 60
  then begin
    TH6.Enabled:=True;
    LLevel.Font.Color:=clRed;
    LLevel.Caption:='Stufe 7';
  end;
end;

procedure TForm1.BPauseClick(Sender: TObject);
begin
MPMusik.Pause;
BPause.Visible:=False;
BPause.Visible:=True;
end;

procedure Fail(Sender: TObject);
begin
Form1.IH.Canvas.Brush.Color:=clRed;
Form1.IH.Canvas.Pen.Color:=clwhite;
Form1.IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Form1.TLi.Enabled:=False;
Form1.TRe.Enabled:=False;
Form1.TOb.Enabled:=False;
Form1.TUn.Enabled:=False;
Form1.TH1.Enabled:=False;
Form1.TH2.Enabled:=False;
Form1.TH3.Enabled:=False;
Form1.TH4.Enabled:=False;
Form1.TH5.Enabled:=False;
Form1.TH6.Enabled:=False;
Form1.TZeit.Enabled:=False;
Form1.TRi.Enabled:=False;
Form1.THV1.Enabled:=False;
Form1.THV2.Enabled:=False;
Aktiv:=False;
Ja:=False;
Form2.Visible:=True;
Form2.LScore.Caption:=IntToStr(Score);
If Score > 30
  then
    if Score >60
      then Form1.MPSound3.Play
      else Form1.MPSound2.Play
  else Form1.MPSound1.Play;
Form2.EName.SetFocus;
//PosX:=200;
//PosY:=200;
//Form1.IH.Canvas.Brush.Color:=clGreen;
//Form1.IH.Canvas.Pen.Color:=clBlack;
//Form1.IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
end;


procedure TForm1.TObTimer(Sender: TObject);  //Bewegen nach Oben
var Abfrage :Integer;
begin
for Abfrage:=PosX to PosX+19 do
  if IH.Canvas.Pixels[Abfrage,PosY-1]= clGray
    then Fail(Form1);
if aktiv = True then
begin
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clwhite;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
IH.Canvas.Rectangle(PosX,PosY+5,PosX+20,Posy+20);
Dec(PosY,5);
IH.Canvas.Brush.Color:=clGreen;
IH.Canvas.Pen.Color:=clBlack;
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Brush.Color:=clGreen;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
end;
Form1.TZeit.Enabled:=True;
end;

procedure TForm1.TUnTimer(Sender: TObject);     //Bewegen nach unten
var Abfrage :Integer;
begin
for Abfrage:=PosX to PosX+19 do
  if IH.Canvas.Pixels[Abfrage,PosY+21]=clGray
    then Fail(Form1);
If Aktiv = True then
begin
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clwhite;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Inc(PosY,5);
IH.Canvas.Brush.Color:=clGreen;
IH.Canvas.Pen.Color:=clBlack;
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Brush.Color:=clGreen;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
end;
Form1.TZeit.Enabled:=True;
end;

procedure TForm1.TReTimer(Sender: TObject);         //Bewegen nach Rechts
var Abfrage :Integer;
begin
for Abfrage:=PosY to PosY+19 do
  if IH.Canvas.Pixels[PosX+20,Abfrage]=clGray
    then Fail(Form1);
if Aktiv= True then
begin
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clwhite;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Inc(PosX,5);
IH.Canvas.Brush.Color:=clGreen;
IH.Canvas.Pen.Color:=clBlack;
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Brush.Color:=clGreen;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
end;
Form1.TZeit.Enabled:=True;
end;

procedure TForm1.TLiTimer(Sender: TObject);              //Bewegen nach Links
var Abfrage :Integer;
begin
for Abfrage:=PosY to PosY+19 do
  if IH.Canvas.Pixels[PosX-1,Abfrage]=clGray
    then Fail(Form1);
  if Aktiv= True
    then
begin
IH.Canvas.Rectangle(PosX,PosY,PosX+19,Posy+20);
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clwhite;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Dec(PosX,5);
IH.Canvas.Brush.Color:=clGreen;
IH.Canvas.Pen.Color:=clBlack;
IH.Canvas.Rectangle(PosX,PosY,PosX+20,Posy+20);
Brush.Color:=clGreen;
//IH.Canvas.FloodFill(PosX+10,PosY+10,clBlack,FSBorder);
end;
Form1.TZeit.Enabled:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
//IH.Canvas.Rectangle(100,100,150,150);
IH.Canvas.Rectangle(0,0,20,400);
IH.Canvas.Rectangle(680,0,700,400);
//IH.Canvas.Rectangle(450,250,470,270);
IH.Canvas.Rectangle(0,350,700,400);
IH.Canvas.Rectangle(0,0,700,50);
H1PosX:=500;
H1PosY:=300;
H2PosX:=200;
H2PosY:=300;
H3PosX:=100;
H3PosY:=300;
H4PosX:=360;
H4PosY:=300;
Song:='Musik/Ben Landis - Chickens';
Songnummer:=1;
LSong.Caption:='Song whlen';
MPMusik.FileName:=Song+'.mp3';
MPMusik.Open;
MPMusik.Notify:=False;
 HighScorePfad := ('Highscores.dat');
  try
   HighScore := TStringList.Create;
  finally
   if FileExists(HighScorePfad) then
    HighScore.LoadFromFile(HighScorePfad)
 else
  begin
   HighScore.Add('00102     Yannik');
   HighScore.Add('00046     Tim');
   HighScore.Add('00024     Herbert');
   end;
 end;
 for i := 0 to highscore.count - 1 do
  begin
   LBAnzeige.items.add(HighScore[i]);
  end;
LLevel.Caption:='Stufe';
end;


procedure TForm1.TH1Timer(Sender: TObject);
var Abfrage : Integer;
begin
if H1Richtung = 1                                                 //unten Abfrage
then begin
      for Abfrage:=H1PosX to H1PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H1PosY+40]=clGray
          then begin
            H1Richtung := 2;
            exit;
          end;
      for Abfrage:=H1PosX to H1PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H1PosY+40]=clBlack
          then Fail(Form1);
     end;
if H1Richtung = 2                                               //oben Abfrage
then begin
      for Abfrage:=H1PosX to H1PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H1PosY-1]=clGray
          then begin
            H1Richtung := 1;
            exit;
          end;
      for Abfrage:=H1PosX to H1PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H1PosY-1]=clBlack
          then Fail(Form1);
     end;
if H1Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=H1PosY to H1PosY+40 do
        if IH.Canvas.Pixels[H1PosX-1,Abfrage]=clGray
          then begin
            H1Richtung := 4;
            exit;
            end;
      for Abfrage:=H1PosY to H1PosY+40 do
        if IH.Canvas.Pixels[H1PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if H1Richtung = 4
then begin
      for Abfrage:=H1PosY to H1PosY+40 do
        if IH.Canvas.Pixels[H1PosX+40,Abfrage]=clGray
          then begin
            H1Richtung := 3;
            exit;
            end;
      for Abfrage:=H1PosY to H1PosY+40 do
        if IH.Canvas.Pixels[H1PosX+40,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H1PosX,H1PosY,H1PosX+40,H1PosY+40);

If H1Richtung = 1       //unten bewegen
 then
   begin
     Inc(H1PosY,5);
   end;
If H1Richtung = 2      //oben bewegen
  then
    begin
      Dec(H1PosY,5);
    end;
If H1Richtung = 3    //links bewegen
 then
   begin
     Dec(H1PosX,5);
   end;
If H1Richtung = 4    //rechts bewegen
  then
    begin
      Inc(H1PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(H1PosX,H1PosY,H1PosX+40,H1PosY+40);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
TH1.Enabled:=Enabled;
H1PosX:=500;
H1PosY:=200;
H2PosX:=400;
H2PosY:= 250;
H3PosX:=300;
H3PosY:=150;
H2Richtung:=3;
H1Richtung:=2;
H3Richtung:=4;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(0,300,700,400);
IH.Canvas.Rectangle(0,0,700,100);
end;




procedure TForm1.Button4Click(Sender: TObject);
begin
MPMusik.FileName:='Musik.mp3';
MPMusik.Open;
MPMusik.Play;
end;

procedure TForm1.MPMusikNotify(Sender: TObject);     
begin
  if MPMusik.Notify = True then
  begin
    Form1.MPMusik.FileName:=Song+'.mp3';
    Form1.MPMusik.Play;
  end else
  begin
      Form1.MPMusik.Stop;
  end;
end;

procedure TForm1.BPlayClick(Sender: TObject);
begin
{MPMusik.FileName:=Song;
if MPMusik.Mode = mpplaying
  then MPMusik.Pause;
  else      //Falls nicht dirket gewechselt werden soll
    if MPMusik.FileName = Song
      then MPMusik.Play
      else begin
        MPMusik.Position:=0;
        MPMusik.FileName:=Song;
        MPMusik.Play;
        end;



MPMusik.Play;
Form1.MPMusik.Notify:=True;
BPlay.Visible:=False;
BPlay.Visible:=True; }
end;

procedure TForm1.TH2Timer(Sender: TObject);
var Abfrage : Integer;
begin
if H2Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=H2PosX to H2PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H2PosY+40]=clGray
          then begin
            H2Richtung := 2;
            exit;
          end;
      for Abfrage:=H2PosX to H2PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H2PosY+40]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if H2Richtung = 2
then begin
      for Abfrage:=H2PosX to H2PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H2PosY-1]=clGray
          then begin
            H2Richtung := 1;
            exit;
          end;
      for Abfrage:=H2PosX to H2PosX+40 do
        if IH.Canvas.Pixels[Abfrage,H2PosY-1]=clBlack
          then Fail(Form1);
    end;
if H2Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=H2PosY to H2PosY+40 do
        if IH.Canvas.Pixels[H2PosX-1,Abfrage]=clGray
          then begin
            H2Richtung := 4;
            exit;
          end;
      for Abfrage:=H2PosY to H2PosY+40 do
        if IH.Canvas.Pixels[H2PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if H2Richtung = 4
then begin
      for Abfrage:=H2PosY to H2PosY+40 do
        if IH.Canvas.Pixels[H2PosX+40,Abfrage]=clGray
          then begin
            H2Richtung := 3;
            exit;
          end;
      for Abfrage:=H2PosY to H2PosY+40 do
        if IH.Canvas.Pixels[H2PosX+40,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H2PosX,H2PosY,H2PosX+40,H2PosY+40);
If H2Richtung = 1     //unten bewegen
 then
   begin
     Inc(H2PosY,5);
   end;
If H2Richtung = 2     //oben bewegen
  then
    begin
      Dec(H2PosY,5);
    end;
If H2Richtung = 3    //links bewegen
 then
   begin
     Dec(H2PosX,5);
   end;
If H2Richtung = 4    //rechts bewegen
  then
    begin
      Inc(H2PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(H2PosX,H2PosY,H2PosX+40,H2PosY+40);
end;

procedure TForm1.TRiTimer(Sender: TObject);
begin
Randomize;
H1Richtung:=Random(4)+1;
H2Richtung:=Random(4)+1;
H3Richtung:=Random(4)+1;
H4Richtung:=Random(4)+1;
H5Richtung:=Random(4)+1;
end;

procedure TForm1.TH3Timer(Sender: TObject);
var Abfrage : Integer;
begin
if H3Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=H3PosX to H3PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H3PosY+20]=clGray
          then begin
            H3Richtung := 2;
            exit;
          end;
      for Abfrage:=H3PosX to H3PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H3PosY+20]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if H3Richtung = 2
then begin
      for Abfrage:=H3PosX to H3PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H3PosY-1]=clGray
          then begin
            H3Richtung := 1;
            exit;
          end;
      for Abfrage:=H3PosX to H3PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H3PosY-1]=clBlack
          then Fail(Form1);
    end;
if H3Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=H3PosY to H3PosY+19 do
        if IH.Canvas.Pixels[H3PosX-1,Abfrage]=clGray
          then begin
            H3Richtung := 4;
            exit;
          end;
      for Abfrage:=H3PosY to H3PosY+20 do
        if IH.Canvas.Pixels[H3PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if H3Richtung = 4
then begin
      for Abfrage:=H3PosY to H3PosY+19 do
        if IH.Canvas.Pixels[H3PosX+20,Abfrage]=clGray
          then begin
            H3Richtung := 3;
            exit;
          end;
      for Abfrage:=H3PosY to H3PosY+20 do
        if IH.Canvas.Pixels[H3PosX+20,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H3PosX,H3PosY,H3PosX+20,H3PosY+20);
If H3Richtung = 1     //unten bewegen
 then
   begin
     Inc(H3PosY,5);
   end;
If H3Richtung = 2     //oben bewegen
  then
    begin
      Dec(H3PosY,5);
    end;
If H3Richtung = 3    //links bewegen
 then
   begin
     Dec(H3PosX,5);
   end;
If H3Richtung = 4    //rechts bewegen
  then
    begin
      Inc(H3PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(H3PosX,H3PosY,H3PosX+20,H3PosY+20);
end;

procedure TForm1.BBAbbruchClick(Sender: TObject);
begin
close;
end;

procedure TForm1.BBNeuClick(Sender: TObject);
var i : integer;
begin
Score:=0;
BBNeu.Enabled:=False;
BBNeu.Enabled:=True;
Aktiv:=True;
Minuten:=0;
Sekunden:=0;
Form1.TH1.Enabled:=True;
Form1.TH2.Enabled:=True;
//Form1.TH3.Enabled:=True;
//Form1.TH4.Enabled:=True;
//Form1.TZeit.Enabled:=True;
Form1.TRi.Enabled:=True;
LZeit.Caption:='00:00';
LBAnzeige.Clear;
 for i := 0 to highscore.count - 1 do
  begin
   LBAnzeige.items.add(HighScore[i]);
  end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H1PosX,H1PosY,H1PosX+40,H1PosY+40);
IH.Canvas.Rectangle(H2PosX,H2PosY,H2PosX+40,H2PosY+40);
IH.Canvas.Rectangle(H3PosX,H3PosY,H3PosX+20,H3PosY+20);
IH.Canvas.Rectangle(H4PosX,H4PosY,H4PosX+20,H4PosY+20);
IH.Canvas.Rectangle(H5PosX,H5PosY,H5PosX+10,H5PosY+10);
IH.Canvas.Rectangle(H6PosX,H6PosY,H6PosX+10,H6PosY+10);
IH.Canvas.Rectangle(HV1PosX,HV1PosY,HV1PosX+20,HV1PosY+20);
IH.Canvas.Rectangle(HV2PosX,HV2PosY,HV2PosX+30,HV2PosY+30);
LLevel.Font.Color:=clBlack;
LLevel.Caption:='Stufe 1';
delay(1000);
Form1.THV1.Enabled:=True;
Form1.THV2.Enabled:=True;
Inc(AFail,1);
TH3.Enabled:=False;
TH4.Enabled:=False;
TH5.Enabled:=False;
TH6.Enabled:=False;
THV1.Enabled:=False;
THV2.Enabled:=False;
end;



procedure TForm1.LBAnzeigeEnter(Sender: TObject);
begin
LBAnzeige.Visible:=False;
LBAnzeige.Visible:=True;
end;

procedure TForm1.THV1Timer(Sender: TObject);
var Abfrage : Integer;
begin
If PosX > HV1PosX
  then HV1Richtung:=4;
If PosX < HV1PosX
  then HV1Richtung:=3;
If PosY > HV1PosY
  then HV1Richtung:=1;
If PosY < HV1PosY
  then HV1Richtung:=2;
if HV1Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=HV1PosX to HV1PosX+20 do
        if IH.Canvas.Pixels[Abfrage,HV1PosY+20]=clGray
          then begin
            HV1Richtung := 2;
            exit;
          end;
      for Abfrage:=HV1PosX to HV1PosX+20 do
        if IH.Canvas.Pixels[Abfrage,HV1PosY+20]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if HV1Richtung = 2
then begin
      for Abfrage:=HV1PosX to HV1PosX+20 do
        if IH.Canvas.Pixels[Abfrage,HV1PosY-1]=clGray
          then begin
            HV1Richtung := 1;
            exit;
          end;
      for Abfrage:=HV1PosX to HV1PosX+20 do
        if IH.Canvas.Pixels[Abfrage,HV1PosY-1]=clBlack
          then Fail(Form1);
    end;
if HV1Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=HV1PosY to HV1PosY+19 do
        if IH.Canvas.Pixels[HV1PosX-1,Abfrage]=clGray
          then begin
            HV1Richtung := 4;
            exit;
          end;
      for Abfrage:=HV1PosY to HV1PosY+20 do
        if IH.Canvas.Pixels[HV1PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if HV1Richtung = 4
then begin
      for Abfrage:=HV1PosY to HV1PosY+19 do
        if IH.Canvas.Pixels[HV1PosX+20,Abfrage]=clGray
          then begin
            HV1Richtung := 3;
            exit;
          end;
      for Abfrage:=HV1PosY to HV1PosY+20 do
        if IH.Canvas.Pixels[HV1PosX+20,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(HV1PosX,HV1PosY,HV1PosX+20,HV1PosY+20);
If HV1Richtung = 1     //unten bewegen
 then
   begin
     Inc(HV1PosY,5);
   end;
If HV1Richtung = 2     //oben bewegen
  then
    begin
      Dec(HV1PosY,5);
    end;
If HV1Richtung = 3    //links bewegen
 then
   begin
     Dec(HV1PosX,5);
   end;
If HV1Richtung = 4    //rechts bewegen
  then
    begin
      Inc(HV1PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(HV1PosX,HV1PosY,HV1PosX+20,HV1PosY+20);
end;

procedure TForm1.THV2Timer(Sender: TObject);
var Abfrage : Integer;
begin
If PosY > HV2PosY+5
  then HV2Richtung:=1;
If PosY < HV2PosY+5
  then HV2Richtung:=2;
If PosX > HV2PosX+5
  then HV2Richtung:=4;
If PosX < HV2PosX+5
  then HV2Richtung:=3;

if HV2Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=HV2PosX to HV2PosX+30 do
        if IH.Canvas.Pixels[Abfrage,HV2PosY+30]=clGray
          then begin
            HV2Richtung := 2;
            exit;
          end;
      for Abfrage:=HV2PosX to HV2PosX+30 do
        if IH.Canvas.Pixels[Abfrage,HV2PosY+30]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if HV2Richtung = 2
then begin
      for Abfrage:=HV2PosX to HV2PosX+30 do
        if IH.Canvas.Pixels[Abfrage,HV2PosY-1]=clGray
          then begin
            HV2Richtung := 1;
            exit;
          end;
      for Abfrage:=HV2PosX to HV2PosX+30 do
        if IH.Canvas.Pixels[Abfrage,HV2PosY-1]=clBlack
          then Fail(Form1);
    end;
if HV2Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=HV2PosY to HV2PosY+30 do
        if IH.Canvas.Pixels[HV2PosX-1,Abfrage]=clGray
          then begin
            HV2Richtung := 4;
            exit;
          end;
      for Abfrage:=HV2PosY to HV2PosY+30 do
        if IH.Canvas.Pixels[HV2PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if HV2Richtung = 4
then begin
      for Abfrage:=HV2PosY to HV2PosY+19 do
        if IH.Canvas.Pixels[HV2PosX+30,Abfrage]=clGray
          then begin
            HV2Richtung := 3;
            exit;
          end;
      for Abfrage:=HV2PosY to HV2PosY+30 do
        if IH.Canvas.Pixels[HV2PosX+30,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(HV2PosX,HV2PosY,HV2PosX+30,HV2PosY+30);
If HV2Richtung = 1     //unten bewegen
 then
   begin
     Inc(HV2PosY,5);
   end;
If HV2Richtung = 2     //oben bewegen
  then
    begin
      Dec(HV2PosY,5);
    end;
If HV2Richtung = 3    //links bewegen
 then
   begin
     Dec(HV2PosX,5);
   end;
If HV2Richtung = 4    //rechts bewegen
  then
    begin
      Inc(HV2PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(HV2PosX,HV2PosY,HV2PosX+30,HV2PosY+30);
end;

procedure TForm1.TH4Timer(Sender: TObject);
var Abfrage : Integer;
begin
if H4Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=H4PosX to H4PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H4PosY+20]=clGray
          then begin
            H4Richtung := 2;
            exit;
          end;
      for Abfrage:=H4PosX to H4PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H4PosY+20]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if H4Richtung = 2
then begin
      for Abfrage:=H4PosX to H4PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H4PosY-1]=clGray
          then begin
            H4Richtung := 1;
            exit;
          end;
      for Abfrage:=H4PosX to H4PosX+20 do
        if IH.Canvas.Pixels[Abfrage,H4PosY-1]=clBlack
          then Fail(Form1);
    end;
if H4Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=H4PosY to H4PosY+19 do
        if IH.Canvas.Pixels[H4PosX-1,Abfrage]=clGray
          then begin
            H4Richtung := 4;
            exit;
          end;
      for Abfrage:=H4PosY to H4PosY+20 do
        if IH.Canvas.Pixels[H4PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if H4Richtung = 4
then begin
      for Abfrage:=H4PosY to H4PosY+20 do
        if IH.Canvas.Pixels[H4PosX+20,Abfrage]=clGray
          then begin
            H4Richtung := 3;
            exit;
          end;
      for Abfrage:=H4PosY to H4PosY+20 do
        if IH.Canvas.Pixels[H4PosX+20,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H4PosX,H4PosY,H4PosX+20,H4PosY+20);
If H4Richtung = 1     //unten bewegen
 then
   begin
     Inc(H4PosY,5);
   end;
If H4Richtung = 2     //oben bewegen
  then
    begin
      Dec(H4PosY,5);
    end;
If H4Richtung = 3    //links bewegen
 then
   begin
     Dec(H4PosX,5);
   end;
If H4Richtung = 4    //rechts bewegen
  then
    begin
      Inc(H4PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(H4PosX,H4PosY,H4PosX+20,H4PosY+20);
end;

procedure TForm1.BStartClick(Sender: TObject);
//var i : integer;
begin
Aktiv:=True;
TZeit.Enabled:=True;
PosX:=100;
PosY:=200;
with IH.Canvas do
  begin
    Pen.Color:=clBlack;
    Brush.Color:=clGreen;
    Rectangle(PosX,PosY,PosX+20,Posy+20);
    //IH.Canvas.FloodFill(PosX+10,Posy+10, clGreen, fsBorder);
  end;
  TH1.Enabled:=Enabled;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H1PosX,H1PosY,H1PosX+40,H1PosY+40);
IH.Canvas.Rectangle(H2PosX,H2PosY,H2PosX+40,H2PosY+40);
IH.Canvas.Rectangle(H3PosX,H3PosY,H3PosX+20,H3PosY+20);
IH.Canvas.Rectangle(H4PosX,H4PosY,H4PosX+20,H4PosY+20);
H1PosX:=500;
H1PosY:=250;
H2PosX:=400;
H2PosY:= 250;
H3PosX:=300;
H3PosY:=250;
H4PosX:=360;
H4PosY:=250;
H5PosX:=340;
H5PosY:=280;
H6PosX:=340;
H6PosY:=280;
H1Richtung:=1;
H2Richtung:=2;
H3Richtung:=4;
H4Richtung:=4;
H5Richtung:=1;
H6Richtung:=2;
HV1PosY:=150;
HV1PosX:=600;
HV2PosY:=300;
HV2PosX:=60;
//IH.Canvas.Rectangle();
Form1.MPSound1.FileName:='Fail.mp3';
Form1.MPSound1.Open;
Form1.MPSound2.FileName:='Fail2.mp3';
Form1.MPSound2.Open;
Form1.MPSound3.FileName:='GG.mp3';
Form1.MPSound3.Open;
AFail:=1;
//THV1.Enabled:=True;
//THV2.Enabled:=True;
TH3.Enabled:=False;
TH4.Enabled:=False;
BStart.Visible:=False;
BBNeu.Enabled:=True;
LLevel.Caption:='Stufe 1';
end;

procedure TForm1.TH5Timer(Sender: TObject);
var Abfrage : integer;
begin
if H5Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=H5PosX to H5PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H5PosY+10]=clGray
          then begin
            H5Richtung := 2;
            exit;
          end;
      for Abfrage:=H5PosX to H5PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H5PosY+10]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if H5Richtung = 2
then begin
      for Abfrage:=H5PosX to H5PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H5PosY-1]=clGray
          then begin
            H5Richtung := 1;
            exit;
          end;
      for Abfrage:=H5PosX to H5PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H5PosY-1]=clBlack
          then Fail(Form1);
    end;
if H5Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=H5PosY to H5PosY+19 do
        if IH.Canvas.Pixels[H5PosX-1,Abfrage]=clGray
          then begin
            H5Richtung := 4;
            exit;
          end;
      for Abfrage:=H5PosY to H5PosY+10 do
        if IH.Canvas.Pixels[H5PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if H5Richtung = 4
then begin
      for Abfrage:=H5PosY to H5PosY+10 do
        if IH.Canvas.Pixels[H5PosX+10,Abfrage]=clGray
          then begin
            H5Richtung := 3;
            exit;
          end;
      for Abfrage:=H5PosY to H5PosY+10 do
        if IH.Canvas.Pixels[H5PosX+10,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H5PosX,H5PosY,H5PosX+10,H5PosY+10);
If H5Richtung = 1     //unten bewegen
 then
   begin
     Inc(H5PosY,5);
   end;
If H5Richtung = 2     //oben bewegen
  then
    begin
      Dec(H5PosY,5);
    end;
If H5Richtung = 3    //links bewegen
 then
   begin
     Dec(H5PosX,5);
   end;
If H5Richtung = 4    //rechts bewegen
  then
    begin
      Inc(H5PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(H5PosX,H5PosY,H5PosX+10,H5PosY+10);
end;

procedure TForm1.TH6Timer(Sender: TObject);
var Abfrage : Integer;
begin
if H6Richtung = 1                                      //unten Abfrage
then begin
      for Abfrage:=H6PosX to H6PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H6PosY+10]=clGray
          then begin
            H6Richtung := 2;
            exit;
          end;
      for Abfrage:=H6PosX to H6PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H6PosY+10]=clBlack
          then Fail(Form1);
     end;                                                    //oben Abfrage
if H6Richtung = 2
then begin
      for Abfrage:=H6PosX to H6PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H6PosY-1]=clGray
          then begin
            H6Richtung := 1;
            exit;
          end;
      for Abfrage:=H6PosX to H6PosX+10 do
        if IH.Canvas.Pixels[Abfrage,H6PosY-1]=clBlack
          then Fail(Form1);
    end;
if H6Richtung = 3                                                //links Abfrage
then begin
      for Abfrage:=H6PosY to H6PosY+19 do
        if IH.Canvas.Pixels[H6PosX-1,Abfrage]=clGray
          then begin
            H6Richtung := 4;
            exit;
          end;
      for Abfrage:=H6PosY to H6PosY+10 do
        if IH.Canvas.Pixels[H6PosX-1,Abfrage]=clBlack
          then Fail(Form1);
     end;                                                          //rechts  Abfrage
if H6Richtung = 4
then begin
      for Abfrage:=H6PosY to H6PosY+10 do
        if IH.Canvas.Pixels[H6PosX+10,Abfrage]=clGray
          then begin
            H6Richtung := 3;
            exit;
          end;
      for Abfrage:=H6PosY to H6PosY+10 do
        if IH.Canvas.Pixels[H6PosX+10,Abfrage]=clBlack
          then Fail(Form1);
     end;
IH.Canvas.Brush.Color:=clWhite;
IH.Canvas.Pen.Color:=clWhite;
IH.Canvas.Rectangle(H6PosX,H6PosY,H6PosX+10,H6PosY+10);
If H6Richtung = 1     //unten bewegen
 then
   begin
     Inc(H6PosY,5);
   end;
If H6Richtung = 2     //oben bewegen
  then
    begin
      Dec(H6PosY,5);
    end;
If H6Richtung = 3    //links bewegen
 then
   begin
     Dec(H6PosX,5);
   end;
If H6Richtung = 4    //rechts bewegen
  then
    begin
      Inc(H6PosX,5);
    end;
IH.Canvas.Brush.Color:=clGray;
IH.Canvas.Pen.Color:=clGray;
IH.Canvas.Rectangle(H6PosX,H6PosY,H6PosX+10,H6PosY+10);
end;

procedure TForm1.BVorClick(Sender: TObject);
begin
MPMusik.Stop;
  case Songnummer of
    1 :   begin
            Songnummer:=2;
            Song:='Musik/Ben Landis - Adventures in Pixels';
            LSong.Caption:='Ben Landis - Adventures in Pixels';
            MPMusik.FileName:=Song+'.mp3';
         end;
   2 :   begin
           Songnummer:=3;
           Song:='Musik/Vinnie and Spike Theme';
           LSong.Caption:='Vinnie and Spike Theme';
           MPMusik.FileName:=Song+'.mp3';
         end;
   3 :   begin
           Songnummer:=4;
           Song:='Musik/Ben Landis - Chickens';
           LSong.Caption:='Ben Landis - Chickens';
           MPMusik.FileName:=Song+'.mp3';
         end;
   4 :   begin
          Songnummer:=1;
          Song:='Musik/Who Likes to Party';
          LSong.Caption:='Who Likes to Party';
          MPMusik.FileName:=Song+'.mp3';
         end;
  end;
BVor.Visible:=False;
BVor.Visible:=True;
delay(100);
MPMusik.Open;
MPMusik.Play;

end;

procedure TForm1.BZurueckClick(Sender: TObject);
begin
MPMusik.Stop;
  case Songnummer of
    1 :   begin
            Songnummer:=4;
            Song:='Musik/Vinnie and Spike Theme';
            LSong.Caption:='Vinnie and Spike Theme';
            MPMusik.FileName:=Song+'.mp3';
         end;
   2 :   begin
           Songnummer:=1;
           Song:='Musik/Ben Landis - Chickens';
           LSong.Caption:='Ben Landis - Chickens';
           MPMusik.FileName:=Song+'.mp3';
         end;
   3 :   begin
           Songnummer:=2;
           Song:='Musik/Ben Landis - Adventures in Pixels';
           LSong.Caption:='Ben Landis - Adventures in Pixels';
           MPMusik.FileName:=Song+'.mp3';
         end;
   4 :   begin
          Songnummer:=3;
          Song:='Musik/Who Likes to Party';
          LSong.Caption:='Who Likes to Party';
          MPMusik.FileName:=Song+'.mp3';
         end;
  end;
BZurueck.Visible:=False;
BZurueck.Visible:=True;
delay(100);
MPMusik.Open;
MPMusik.Play;

end;

procedure TForm1.LLoopClick(Sender: TObject);
begin
If MPMusik.Notify = True
  then  begin
          MPMusik.Notify:=False;
          LLoop.Font.Color:=clred;
          BPause.Enabled:=True;
          BVor.Enabled:=True;
          BZurueck.Enabled:=True;
          exit;
        end;
If MPMusik.Notify = False
  then  begin
          MPMusik.Notify:=True;
          LLoop.Font.Color:=clBlue;
          BPause.Enabled:=False;
          BVor.Enabled:=False;
          BZurueck.Enabled:=False;
        end;
end;

procedure TForm1.BHilfeMPClick(Sender: TObject);
begin
Showmessage('Mit A bzw D kannst du das Lied whlen.');
Showmessage('Mit W Pausierst du die Musik.');
Showmessage('Mit S Bettigst du den Loop.');
BHilfeMP.Visible:=False;
BHilfeMP.Visible:=True;
end;

procedure TForm1.BHilfeSpielClick(Sender: TObject);
begin
Showmessage('Mit den Pfeiltasten bewegst du dich.');
Showmessage('Ziel ist es, den Hindernissen auszuweichen und solange wie mglich zu berleben.');
Showmessage('Der Score sind die berlebten Sekunden.');
Showmessage('Viel Spass!');
BHilfeSpiel.Visible:=False;
BHilfeSpiel.Visible:=True;
end;

end.
